from qtpy import QtCore, QtGui, QtWidgets
from languagebox import LanguageBox
from sys import platform

from tr import _translate


class Ui_settingsDialog(object):
    def setupUi(self, settingsDialog):
        settingsDialog.setObjectName("settingsDialog")
        settingsDialog.resize(521, 413)
        self.gridLayout = QtWidgets.QGridLayout(settingsDialog)
        self.gridLayout.setObjectName("gridLayout")
        self.buttonBox = QtWidgets.QDialogButtonBox(settingsDialog)
        self.buttonBox.setOrientation(QtCore.Qt.Horizontal)
        self.buttonBox.setStandardButtons(QtWidgets.QDialogButtonBox.Cancel|QtWidgets.QDialogButtonBox.Ok)
        self.buttonBox.setObjectName("buttonBox")
        self.gridLayout.addWidget(self.buttonBox, 1, 0, 1, 1)
        self.tabWidgetSettings = QtWidgets.QTabWidget(settingsDialog)
        self.tabWidgetSettings.setObjectName("tabWidgetSettings")
        self.tabUserInterface = QtWidgets.QWidget()
        self.tabUserInterface.setEnabled(True)
        self.tabUserInterface.setObjectName("tabUserInterface")
        self.formLayout = QtWidgets.QFormLayout(self.tabUserInterface)
        self.formLayout.setObjectName("formLayout")
        self.checkBoxStartOnLogon = QtWidgets.QCheckBox(self.tabUserInterface)
        self.checkBoxStartOnLogon.setObjectName("checkBoxStartOnLogon")
        self.formLayout.setWidget(0, QtWidgets.QFormLayout.LabelRole, self.checkBoxStartOnLogon)
        self.groupBoxTray = QtWidgets.QGroupBox(self.tabUserInterface)
        self.groupBoxTray.setObjectName("groupBoxTray")
        self.formLayoutTray = QtWidgets.QFormLayout(self.groupBoxTray)
        self.formLayoutTray.setObjectName("formLayoutTray")
        self.checkBoxStartInTray = QtWidgets.QCheckBox(self.groupBoxTray)
        self.checkBoxStartInTray.setObjectName("checkBoxStartInTray")
        self.formLayoutTray.setWidget(0, QtWidgets.QFormLayout.SpanningRole, self.checkBoxStartInTray)
        self.checkBoxMinimizeToTray = QtWidgets.QCheckBox(self.groupBoxTray)
        self.checkBoxMinimizeToTray.setChecked(True)
        self.checkBoxMinimizeToTray.setObjectName("checkBoxMinimizeToTray")
        self.formLayoutTray.setWidget(1, QtWidgets.QFormLayout.LabelRole, self.checkBoxMinimizeToTray)
        self.checkBoxTrayOnClose = QtWidgets.QCheckBox(self.groupBoxTray)
        self.checkBoxTrayOnClose.setChecked(True)
        self.checkBoxTrayOnClose.setObjectName("checkBoxTrayOnClose")
        self.formLayoutTray.setWidget(2, QtWidgets.QFormLayout.LabelRole, self.checkBoxTrayOnClose)
        self.formLayout.setWidget(1, QtWidgets.QFormLayout.SpanningRole, self.groupBoxTray)
        self.checkBoxHideTrayConnectionNotifications = QtWidgets.QCheckBox(self.tabUserInterface)
        self.checkBoxHideTrayConnectionNotifications.setChecked(False)
        self.checkBoxHideTrayConnectionNotifications.setObjectName("checkBoxHideTrayConnectionNotifications")
        self.formLayout.setWidget(2, QtWidgets.QFormLayout.LabelRole, self.checkBoxHideTrayConnectionNotifications)
        self.checkBoxShowTrayNotifications = QtWidgets.QCheckBox(self.tabUserInterface)
        self.checkBoxShowTrayNotifications.setObjectName("checkBoxShowTrayNotifications")
        self.formLayout.setWidget(3, QtWidgets.QFormLayout.LabelRole, self.checkBoxShowTrayNotifications)
        self.checkBoxPortableMode = QtWidgets.QCheckBox(self.tabUserInterface)
        self.checkBoxPortableMode.setObjectName("checkBoxPortableMode")
        self.formLayout.setWidget(4, QtWidgets.QFormLayout.LabelRole, self.checkBoxPortableMode)
        self.PortableModeDescription = QtWidgets.QLabel(self.tabUserInterface)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Minimum, QtWidgets.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.PortableModeDescription.sizePolicy().hasHeightForWidth())
        self.PortableModeDescription.setSizePolicy(sizePolicy)
        self.PortableModeDescription.setWordWrap(True)
        self.PortableModeDescription.setObjectName("PortableModeDescription")
        self.formLayout.setWidget(5, QtWidgets.QFormLayout.SpanningRole, self.PortableModeDescription)
        self.checkBoxWillinglySendToMobile = QtWidgets.QCheckBox(self.tabUserInterface)
        self.checkBoxWillinglySendToMobile.setObjectName("checkBoxWillinglySendToMobile")
        self.formLayout.setWidget(6, QtWidgets.QFormLayout.SpanningRole, self.checkBoxWillinglySendToMobile)
        self.checkBoxUseIdenticons = QtWidgets.QCheckBox(self.tabUserInterface)
        self.checkBoxUseIdenticons.setObjectName("checkBoxUseIdenticons")
        self.formLayout.setWidget(7, QtWidgets.QFormLayout.LabelRole, self.checkBoxUseIdenticons)
        self.checkBoxReplyBelow = QtWidgets.QCheckBox(self.tabUserInterface)
        self.checkBoxReplyBelow.setObjectName("checkBoxReplyBelow")
        self.formLayout.setWidget(8, QtWidgets.QFormLayout.LabelRole, self.checkBoxReplyBelow)
        self.groupBox = QtWidgets.QGroupBox(self.tabUserInterface)
        self.groupBox.setObjectName("groupBox")
        self.formLayout_2 = QtWidgets.QFormLayout(self.groupBox)
        self.formLayout_2.setObjectName("formLayout_2")
        self.languageComboBox = LanguageBox(self.groupBox)
        self.languageComboBox.setMinimumSize(QtCore.QSize(100, 0))
        self.languageComboBox.setObjectName("languageComboBox")
        self.formLayout_2.setWidget(0, QtWidgets.QFormLayout.LabelRole, self.languageComboBox)
        self.formLayout.setWidget(9, QtWidgets.QFormLayout.FieldRole, self.groupBox)
        self.tabWidgetSettings.addTab(self.tabUserInterface, "")
        self.tabNetworkSettings = QtWidgets.QWidget()
        self.tabNetworkSettings.setObjectName("tabNetworkSettings")
        self.gridLayout_4 = QtWidgets.QGridLayout(self.tabNetworkSettings)
        self.gridLayout_4.setObjectName("gridLayout_4")
        self.groupBox1 = QtWidgets.QGroupBox(self.tabNetworkSettings)
        self.groupBox1.setObjectName("groupBox1")
        self.gridLayout_3 = QtWidgets.QGridLayout(self.groupBox1)
        self.gridLayout_3.setObjectName("gridLayout_3")
        #spacerItem = QtWidgets.QSpacerItem(125, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        #self.gridLayout_3.addItem(spacerItem, 0, 0, 1, 1)
        self.label = QtWidgets.QLabel(self.groupBox1)
        self.label.setObjectName("label")
        self.gridLayout_3.addWidget(self.label, 0, 0, 1, 1, QtCore.Qt.AlignRight)
        self.lineEditTCPPort = QtWidgets.QLineEdit(self.groupBox1)
        self.lineEditTCPPort.setMaximumSize(QtCore.QSize(70, 16777215))
        self.lineEditTCPPort.setObjectName("lineEditTCPPort")
        self.gridLayout_3.addWidget(self.lineEditTCPPort, 0, 1, 1, 1, QtCore.Qt.AlignLeft)
        self.labelUPnP = QtWidgets.QLabel(self.groupBox1)
        self.labelUPnP.setObjectName("labelUPnP")
        self.gridLayout_3.addWidget(self.labelUPnP, 0, 2, 1, 1, QtCore.Qt.AlignRight)
        self.checkBoxUPnP = QtWidgets.QCheckBox(self.groupBox1)
        self.checkBoxUPnP.setObjectName("checkBoxUPnP")
        self.gridLayout_3.addWidget(self.checkBoxUPnP, 0, 3, 1, 1, QtCore.Qt.AlignLeft)
        self.gridLayout_4.addWidget(self.groupBox1, 0, 0, 1, 1)
        self.groupBox_3 = QtWidgets.QGroupBox(self.tabNetworkSettings)
        self.groupBox_3.setObjectName("groupBox_3")
        self.gridLayout_9 = QtWidgets.QGridLayout(self.groupBox_3)
        self.gridLayout_9.setObjectName("gridLayout_9")
        spacerItem1 = QtWidgets.QSpacerItem(40, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_9.addItem(spacerItem1, 0, 0, 2, 1)
        self.label_24 = QtWidgets.QLabel(self.groupBox_3)
        self.label_24.setObjectName("label_24")
        self.gridLayout_9.addWidget(self.label_24, 0, 1, 1, 1)
        self.lineEditMaxDownloadRate = QtWidgets.QLineEdit(self.groupBox_3)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lineEditMaxDownloadRate.sizePolicy().hasHeightForWidth())
        self.lineEditMaxDownloadRate.setSizePolicy(sizePolicy)
        self.lineEditMaxDownloadRate.setMaximumSize(QtCore.QSize(60, 16777215))
        self.lineEditMaxDownloadRate.setObjectName("lineEditMaxDownloadRate")
        self.gridLayout_9.addWidget(self.lineEditMaxDownloadRate, 0, 2, 1, 1)
        self.label_25 = QtWidgets.QLabel(self.groupBox_3)
        self.label_25.setObjectName("label_25")
        self.gridLayout_9.addWidget(self.label_25, 1, 1, 1, 1)
        self.lineEditMaxUploadRate = QtWidgets.QLineEdit(self.groupBox_3)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lineEditMaxUploadRate.sizePolicy().hasHeightForWidth())
        self.lineEditMaxUploadRate.setSizePolicy(sizePolicy)
        self.lineEditMaxUploadRate.setMaximumSize(QtCore.QSize(60, 16777215))
        self.lineEditMaxUploadRate.setObjectName("lineEditMaxUploadRate")
        self.gridLayout_9.addWidget(self.lineEditMaxUploadRate, 1, 2, 1, 1)
        self.label_26 = QtWidgets.QLabel(self.groupBox_3)
        self.label_26.setObjectName("label_26")
        self.gridLayout_9.addWidget(self.label_26, 2, 1, 1, 1)
        self.lineEditMaxOutboundConnections = QtWidgets.QLineEdit(self.groupBox_3)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lineEditMaxOutboundConnections.sizePolicy().hasHeightForWidth())
        self.lineEditMaxOutboundConnections.setSizePolicy(sizePolicy)
        self.lineEditMaxOutboundConnections.setMaximumSize(QtCore.QSize(60, 16777215))
        self.lineEditMaxOutboundConnections.setObjectName("lineEditMaxOutboundConnections")
        self.lineEditMaxOutboundConnections.setValidator(QtGui.QIntValidator(0, 8, self.lineEditMaxOutboundConnections))
        self.gridLayout_9.addWidget(self.lineEditMaxOutboundConnections, 2, 2, 1, 1)
        self.gridLayout_4.addWidget(self.groupBox_3, 2, 0, 1, 1)
        self.groupBox_2 = QtWidgets.QGroupBox(self.tabNetworkSettings)
        self.groupBox_2.setObjectName("groupBox_2")
        self.gridLayout_2 = QtWidgets.QGridLayout(self.groupBox_2)
        self.gridLayout_2.setObjectName("gridLayout_2")
        self.label_2 = QtWidgets.QLabel(self.groupBox_2)
        self.label_2.setObjectName("label_2")
        self.gridLayout_2.addWidget(self.label_2, 0, 0, 1, 1)
        self.label_3 = QtWidgets.QLabel(self.groupBox_2)
        self.label_3.setObjectName("label_3")
        self.gridLayout_2.addWidget(self.label_3, 1, 1, 1, 1)
        self.lineEditSocksHostname = QtWidgets.QLineEdit(self.groupBox_2)
        self.lineEditSocksHostname.setObjectName("lineEditSocksHostname")
        self.lineEditSocksHostname.setPlaceholderText("127.0.0.1")
        self.gridLayout_2.addWidget(self.lineEditSocksHostname, 1, 2, 1, 2)
        self.label_4 = QtWidgets.QLabel(self.groupBox_2)
        self.label_4.setObjectName("label_4")
        self.gridLayout_2.addWidget(self.label_4, 1, 4, 1, 1)
        self.lineEditSocksPort = QtWidgets.QLineEdit(self.groupBox_2)
        self.lineEditSocksPort.setObjectName("lineEditSocksPort")
        if platform in ['darwin', 'win32', 'win64']:
            self.lineEditSocksPort.setPlaceholderText("9150")
        else:
            self.lineEditSocksPort.setPlaceholderText("9050")
        self.gridLayout_2.addWidget(self.lineEditSocksPort, 1, 5, 1, 1)
        self.checkBoxAuthentication = QtWidgets.QCheckBox(self.groupBox_2)
        self.checkBoxAuthentication.setObjectName("checkBoxAuthentication")
        self.gridLayout_2.addWidget(self.checkBoxAuthentication, 2, 1, 1, 1)
        self.label_5 = QtWidgets.QLabel(self.groupBox_2)
        self.label_5.setObjectName("label_5")
        self.gridLayout_2.addWidget(self.label_5, 2, 2, 1, 1)
        self.lineEditSocksUsername = QtWidgets.QLineEdit(self.groupBox_2)
        self.lineEditSocksUsername.setEnabled(False)
        self.lineEditSocksUsername.setObjectName("lineEditSocksUsername")
        self.gridLayout_2.addWidget(self.lineEditSocksUsername, 2, 3, 1, 1)
        self.label_6 = QtWidgets.QLabel(self.groupBox_2)
        self.label_6.setObjectName("label_6")
        self.gridLayout_2.addWidget(self.label_6, 2, 4, 1, 1)
        self.lineEditSocksPassword = QtWidgets.QLineEdit(self.groupBox_2)
        self.lineEditSocksPassword.setEnabled(False)
        self.lineEditSocksPassword.setInputMethodHints(QtCore.Qt.ImhHiddenText|QtCore.Qt.ImhNoAutoUppercase|QtCore.Qt.ImhNoPredictiveText)
        self.lineEditSocksPassword.setEchoMode(QtWidgets.QLineEdit.Password)
        self.lineEditSocksPassword.setObjectName("lineEditSocksPassword")
        self.gridLayout_2.addWidget(self.lineEditSocksPassword, 2, 5, 1, 1)
        self.checkBoxSocksListen = QtWidgets.QCheckBox(self.groupBox_2)
        self.checkBoxSocksListen.setObjectName("checkBoxSocksListen")
        self.gridLayout_2.addWidget(self.checkBoxSocksListen, 3, 1, 1, 4)
        self.comboBoxProxyType = QtWidgets.QComboBox(self.groupBox_2)
        self.comboBoxProxyType.setObjectName("comboBoxProxyType")
        self.comboBoxProxyType.addItem("")
        self.comboBoxProxyType.addItem("")
        self.comboBoxProxyType.addItem("")
        self.gridLayout_2.addWidget(self.comboBoxProxyType, 0, 1, 1, 1)
        self.gridLayout_4.addWidget(self.groupBox_2, 1, 0, 1, 1)
        spacerItem2 = QtWidgets.QSpacerItem(20, 40, QtWidgets.QSizePolicy.Minimum, QtWidgets.QSizePolicy.Expanding)
        self.gridLayout_4.addItem(spacerItem2, 3, 0, 1, 1)
        self.tabWidgetSettings.addTab(self.tabNetworkSettings, "")
        self.tabDemandedDifficulty = QtWidgets.QWidget()
        self.tabDemandedDifficulty.setObjectName("tabDemandedDifficulty")
        self.gridLayout_6 = QtWidgets.QGridLayout(self.tabDemandedDifficulty)
        self.gridLayout_6.setObjectName("gridLayout_6")
        self.label_9 = QtWidgets.QLabel(self.tabDemandedDifficulty)
        self.label_9.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_9.setObjectName("label_9")
        self.gridLayout_6.addWidget(self.label_9, 1, 1, 1, 1)
        self.label_10 = QtWidgets.QLabel(self.tabDemandedDifficulty)
        self.label_10.setWordWrap(True)
        self.label_10.setObjectName("label_10")
        self.gridLayout_6.addWidget(self.label_10, 2, 0, 1, 3)
        self.label_11 = QtWidgets.QLabel(self.tabDemandedDifficulty)
        self.label_11.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_11.setObjectName("label_11")
        self.gridLayout_6.addWidget(self.label_11, 3, 1, 1, 1)
        self.label_8 = QtWidgets.QLabel(self.tabDemandedDifficulty)
        self.label_8.setWordWrap(True)
        self.label_8.setObjectName("label_8")
        self.gridLayout_6.addWidget(self.label_8, 0, 0, 1, 3)
        spacerItem3 = QtWidgets.QSpacerItem(203, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_6.addItem(spacerItem3, 1, 0, 1, 1)
        self.label_12 = QtWidgets.QLabel(self.tabDemandedDifficulty)
        self.label_12.setWordWrap(True)
        self.label_12.setObjectName("label_12")
        self.gridLayout_6.addWidget(self.label_12, 4, 0, 1, 3)
        self.lineEditSmallMessageDifficulty = QtWidgets.QLineEdit(self.tabDemandedDifficulty)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lineEditSmallMessageDifficulty.sizePolicy().hasHeightForWidth())
        self.lineEditSmallMessageDifficulty.setSizePolicy(sizePolicy)
        self.lineEditSmallMessageDifficulty.setMaximumSize(QtCore.QSize(70, 16777215))
        self.lineEditSmallMessageDifficulty.setObjectName("lineEditSmallMessageDifficulty")
        self.gridLayout_6.addWidget(self.lineEditSmallMessageDifficulty, 3, 2, 1, 1)
        self.lineEditTotalDifficulty = QtWidgets.QLineEdit(self.tabDemandedDifficulty)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lineEditTotalDifficulty.sizePolicy().hasHeightForWidth())
        self.lineEditTotalDifficulty.setSizePolicy(sizePolicy)
        self.lineEditTotalDifficulty.setMaximumSize(QtCore.QSize(70, 16777215))
        self.lineEditTotalDifficulty.setObjectName("lineEditTotalDifficulty")
        self.gridLayout_6.addWidget(self.lineEditTotalDifficulty, 1, 2, 1, 1)
        spacerItem4 = QtWidgets.QSpacerItem(203, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_6.addItem(spacerItem4, 3, 0, 1, 1)
        spacerItem5 = QtWidgets.QSpacerItem(20, 40, QtWidgets.QSizePolicy.Minimum, QtWidgets.QSizePolicy.Expanding)
        self.gridLayout_6.addItem(spacerItem5, 5, 0, 1, 1)
        self.tabWidgetSettings.addTab(self.tabDemandedDifficulty, "")
        self.tabMaxAcceptableDifficulty = QtWidgets.QWidget()
        self.tabMaxAcceptableDifficulty.setObjectName("tabMaxAcceptableDifficulty")
        self.gridLayout_7 = QtWidgets.QGridLayout(self.tabMaxAcceptableDifficulty)
        self.gridLayout_7.setObjectName("gridLayout_7")
        self.label_15 = QtWidgets.QLabel(self.tabMaxAcceptableDifficulty)
        self.label_15.setWordWrap(True)
        self.label_15.setObjectName("label_15")
        self.gridLayout_7.addWidget(self.label_15, 0, 0, 1, 3)
        spacerItem6 = QtWidgets.QSpacerItem(102, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_7.addItem(spacerItem6, 1, 0, 1, 1)
        self.label_13 = QtWidgets.QLabel(self.tabMaxAcceptableDifficulty)
        self.label_13.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.label_13.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_13.setObjectName("label_13")
        self.gridLayout_7.addWidget(self.label_13, 1, 1, 1, 1)
        self.lineEditMaxAcceptableTotalDifficulty = QtWidgets.QLineEdit(self.tabMaxAcceptableDifficulty)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lineEditMaxAcceptableTotalDifficulty.sizePolicy().hasHeightForWidth())
        self.lineEditMaxAcceptableTotalDifficulty.setSizePolicy(sizePolicy)
        self.lineEditMaxAcceptableTotalDifficulty.setMaximumSize(QtCore.QSize(70, 16777215))
        self.lineEditMaxAcceptableTotalDifficulty.setObjectName("lineEditMaxAcceptableTotalDifficulty")
        self.gridLayout_7.addWidget(self.lineEditMaxAcceptableTotalDifficulty, 1, 2, 1, 1)
        spacerItem7 = QtWidgets.QSpacerItem(102, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_7.addItem(spacerItem7, 2, 0, 1, 1)
        self.label_14 = QtWidgets.QLabel(self.tabMaxAcceptableDifficulty)
        self.label_14.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_14.setObjectName("label_14")
        self.gridLayout_7.addWidget(self.label_14, 2, 1, 1, 1)
        self.lineEditMaxAcceptableSmallMessageDifficulty = QtWidgets.QLineEdit(self.tabMaxAcceptableDifficulty)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lineEditMaxAcceptableSmallMessageDifficulty.sizePolicy().hasHeightForWidth())
        self.lineEditMaxAcceptableSmallMessageDifficulty.setSizePolicy(sizePolicy)
        self.lineEditMaxAcceptableSmallMessageDifficulty.setMaximumSize(QtCore.QSize(70, 16777215))
        self.lineEditMaxAcceptableSmallMessageDifficulty.setObjectName("lineEditMaxAcceptableSmallMessageDifficulty")
        self.gridLayout_7.addWidget(self.lineEditMaxAcceptableSmallMessageDifficulty, 2, 2, 1, 1)
        spacerItem8 = QtWidgets.QSpacerItem(20, 147, QtWidgets.QSizePolicy.Minimum, QtWidgets.QSizePolicy.Expanding)
        self.gridLayout_7.addItem(spacerItem8, 3, 1, 1, 1)
        self.labelOpenCL = QtWidgets.QLabel(self.tabMaxAcceptableDifficulty)
        self.labelOpenCL.setObjectName("labelOpenCL")
        self.gridLayout_7.addWidget(self.labelOpenCL, 4, 0, 1, 1)
        self.comboBoxOpenCL = QtWidgets.QComboBox(self.tabMaxAcceptableDifficulty)
        self.comboBoxOpenCL.setObjectName = ("comboBoxOpenCL")
        self.gridLayout_7.addWidget(self.comboBoxOpenCL, 4, 1, 1, 1)
        self.tabWidgetSettings.addTab(self.tabMaxAcceptableDifficulty, "")
        self.tabNamecoin = QtWidgets.QWidget()
        self.tabNamecoin.setObjectName("tabNamecoin")
        self.gridLayout_8 = QtWidgets.QGridLayout(self.tabNamecoin)
        self.gridLayout_8.setObjectName("gridLayout_8")
        spacerItem9 = QtWidgets.QSpacerItem(40, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_8.addItem(spacerItem9, 2, 0, 1, 1)
        self.label_16 = QtWidgets.QLabel(self.tabNamecoin)
        self.label_16.setWordWrap(True)
        self.label_16.setObjectName("label_16")
        self.gridLayout_8.addWidget(self.label_16, 0, 0, 1, 3)
        self.label_17 = QtWidgets.QLabel(self.tabNamecoin)
        self.label_17.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_17.setObjectName("label_17")
        self.gridLayout_8.addWidget(self.label_17, 2, 1, 1, 1)
        self.lineEditNamecoinHost = QtWidgets.QLineEdit(self.tabNamecoin)
        self.lineEditNamecoinHost.setObjectName("lineEditNamecoinHost")
        self.gridLayout_8.addWidget(self.lineEditNamecoinHost, 2, 2, 1, 1)
        spacerItem10 = QtWidgets.QSpacerItem(40, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_8.addItem(spacerItem10, 3, 0, 1, 1)
        spacerItem11 = QtWidgets.QSpacerItem(40, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_8.addItem(spacerItem11, 4, 0, 1, 1)
        self.label_18 = QtWidgets.QLabel(self.tabNamecoin)
        self.label_18.setEnabled(True)
        self.label_18.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_18.setObjectName("label_18")
        self.gridLayout_8.addWidget(self.label_18, 3, 1, 1, 1)
        self.lineEditNamecoinPort = QtWidgets.QLineEdit(self.tabNamecoin)
        self.lineEditNamecoinPort.setObjectName("lineEditNamecoinPort")
        self.gridLayout_8.addWidget(self.lineEditNamecoinPort, 3, 2, 1, 1)
        spacerItem12 = QtWidgets.QSpacerItem(20, 40, QtWidgets.QSizePolicy.Minimum, QtWidgets.QSizePolicy.Expanding)
        self.gridLayout_8.addItem(spacerItem12, 8, 1, 1, 1)
        self.labelNamecoinUser = QtWidgets.QLabel(self.tabNamecoin)
        self.labelNamecoinUser.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.labelNamecoinUser.setObjectName("labelNamecoinUser")
        self.gridLayout_8.addWidget(self.labelNamecoinUser, 4, 1, 1, 1)
        self.lineEditNamecoinUser = QtWidgets.QLineEdit(self.tabNamecoin)
        self.lineEditNamecoinUser.setObjectName("lineEditNamecoinUser")
        self.gridLayout_8.addWidget(self.lineEditNamecoinUser, 4, 2, 1, 1)
        spacerItem13 = QtWidgets.QSpacerItem(40, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_8.addItem(spacerItem13, 5, 0, 1, 1)
        self.labelNamecoinPassword = QtWidgets.QLabel(self.tabNamecoin)
        self.labelNamecoinPassword.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.labelNamecoinPassword.setObjectName("labelNamecoinPassword")
        self.gridLayout_8.addWidget(self.labelNamecoinPassword, 5, 1, 1, 1)
        self.lineEditNamecoinPassword = QtWidgets.QLineEdit(self.tabNamecoin)
        self.lineEditNamecoinPassword.setInputMethodHints(QtCore.Qt.ImhHiddenText|QtCore.Qt.ImhNoAutoUppercase|QtCore.Qt.ImhNoPredictiveText)
        self.lineEditNamecoinPassword.setEchoMode(QtWidgets.QLineEdit.Password)
        self.lineEditNamecoinPassword.setObjectName("lineEditNamecoinPassword")
        self.gridLayout_8.addWidget(self.lineEditNamecoinPassword, 5, 2, 1, 1)
        self.labelNamecoinTestResult = QtWidgets.QLabel(self.tabNamecoin)
        self.labelNamecoinTestResult.setText("")
        self.labelNamecoinTestResult.setObjectName("labelNamecoinTestResult")
        self.gridLayout_8.addWidget(self.labelNamecoinTestResult, 7, 0, 1, 2)
        self.pushButtonNamecoinTest = QtWidgets.QPushButton(self.tabNamecoin)
        self.pushButtonNamecoinTest.setObjectName("pushButtonNamecoinTest")
        self.gridLayout_8.addWidget(self.pushButtonNamecoinTest, 7, 2, 1, 1)
        self.horizontalLayout = QtWidgets.QHBoxLayout()
        self.horizontalLayout.setObjectName("horizontalLayout")
        self.label_21 = QtWidgets.QLabel(self.tabNamecoin)
        self.label_21.setObjectName("label_21")
        self.horizontalLayout.addWidget(self.label_21)
        self.radioButtonNamecoinNamecoind = QtWidgets.QRadioButton(self.tabNamecoin)
        self.radioButtonNamecoinNamecoind.setObjectName("radioButtonNamecoinNamecoind")
        self.horizontalLayout.addWidget(self.radioButtonNamecoinNamecoind)
        self.radioButtonNamecoinNmcontrol = QtWidgets.QRadioButton(self.tabNamecoin)
        self.radioButtonNamecoinNmcontrol.setObjectName("radioButtonNamecoinNmcontrol")
        self.horizontalLayout.addWidget(self.radioButtonNamecoinNmcontrol)
        self.gridLayout_8.addLayout(self.horizontalLayout, 1, 0, 1, 3)
        self.tabWidgetSettings.addTab(self.tabNamecoin, "")
        self.tabResendsExpire = QtWidgets.QWidget()
        self.tabResendsExpire.setObjectName("tabResendsExpire")
        self.gridLayout_5 = QtWidgets.QGridLayout(self.tabResendsExpire)
        self.gridLayout_5.setObjectName("gridLayout_5")
        self.label_7 = QtWidgets.QLabel(self.tabResendsExpire)
        self.label_7.setWordWrap(True)
        self.label_7.setObjectName("label_7")
        self.gridLayout_5.addWidget(self.label_7, 0, 0, 1, 3)
        spacerItem14 = QtWidgets.QSpacerItem(212, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_5.addItem(spacerItem14, 1, 0, 1, 1)
        self.widget = QtWidgets.QWidget(self.tabResendsExpire)
        self.widget.setMinimumSize(QtCore.QSize(231, 75))
        self.widget.setObjectName("widget")
        self.label_19 = QtWidgets.QLabel(self.widget)
        self.label_19.setGeometry(QtCore.QRect(10, 20, 101, 20))
        self.label_19.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_19.setObjectName("label_19")
        self.label_20 = QtWidgets.QLabel(self.widget)
        self.label_20.setGeometry(QtCore.QRect(30, 40, 80, 16))
        self.label_20.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_20.setObjectName("label_20")
        self.lineEditDays = QtWidgets.QLineEdit(self.widget)
        self.lineEditDays.setGeometry(QtCore.QRect(113, 20, 51, 20))
        self.lineEditDays.setObjectName("lineEditDays")
        self.lineEditMonths = QtWidgets.QLineEdit(self.widget)
        self.lineEditMonths.setGeometry(QtCore.QRect(113, 40, 51, 20))
        self.lineEditMonths.setObjectName("lineEditMonths")
        self.label_22 = QtWidgets.QLabel(self.widget)
        self.label_22.setGeometry(QtCore.QRect(169, 23, 61, 16))
        self.label_22.setObjectName("label_22")
        self.label_23 = QtWidgets.QLabel(self.widget)
        self.label_23.setGeometry(QtCore.QRect(170, 41, 71, 16))
        self.label_23.setObjectName("label_23")
        self.gridLayout_5.addWidget(self.widget, 1, 2, 1, 1)
        spacerItem15 = QtWidgets.QSpacerItem(20, 129, QtWidgets.QSizePolicy.Minimum, QtWidgets.QSizePolicy.Expanding)
        self.gridLayout_5.addItem(spacerItem15, 2, 1, 1, 1)
        self.tabWidgetSettings.addTab(self.tabResendsExpire, "")
        self.gridLayout.addWidget(self.tabWidgetSettings, 0, 0, 1, 1)

        self.retranslateUi(settingsDialog)
        self.tabWidgetSettings.setCurrentIndex(0)

        self.buttonBox.accepted.connect(settingsDialog.accept)
        self.buttonBox.rejected.connect(settingsDialog.reject)
        self.checkBoxAuthentication.toggled.connect(
            self.lineEditSocksUsername.setEnabled)
        self.checkBoxAuthentication.toggled.connect(
            self.lineEditSocksPassword.setEnabled)

        QtCore.QMetaObject.connectSlotsByName(settingsDialog)

        settingsDialog.setTabOrder(self.tabWidgetSettings, self.checkBoxStartOnLogon)
        settingsDialog.setTabOrder(self.checkBoxStartOnLogon, self.checkBoxStartInTray)
        settingsDialog.setTabOrder(self.checkBoxStartInTray, self.checkBoxMinimizeToTray)
        settingsDialog.setTabOrder(self.checkBoxMinimizeToTray, self.lineEditTCPPort)
        settingsDialog.setTabOrder(self.lineEditTCPPort, self.comboBoxProxyType)
        settingsDialog.setTabOrder(self.comboBoxProxyType, self.lineEditSocksHostname)
        settingsDialog.setTabOrder(self.lineEditSocksHostname, self.lineEditSocksPort)
        settingsDialog.setTabOrder(self.lineEditSocksPort, self.checkBoxAuthentication)
        settingsDialog.setTabOrder(self.checkBoxAuthentication, self.lineEditSocksUsername)
        settingsDialog.setTabOrder(self.lineEditSocksUsername, self.lineEditSocksPassword)
        settingsDialog.setTabOrder(self.lineEditSocksPassword, self.checkBoxSocksListen)
        settingsDialog.setTabOrder(self.checkBoxSocksListen, self.buttonBox)

    def retranslateUi(self, settingsDialog):
        settingsDialog.setWindowTitle(_translate("settingsDialog", "Settings", None))
        self.checkBoxStartOnLogon.setText(_translate("settingsDialog", "Start Bitmessage on user login", None))
        self.groupBoxTray.setTitle(_translate("settingsDialog", "Tray", None))
        self.checkBoxStartInTray.setText(_translate("settingsDialog", "Start Bitmessage in the tray (don\'t show main window)", None))
        self.checkBoxMinimizeToTray.setText(_translate("settingsDialog", "Minimize to tray", None))
        self.checkBoxTrayOnClose.setText(_translate("settingsDialog", "Close to tray", None))
        self.checkBoxHideTrayConnectionNotifications.setText(_translate("settingsDialog", "Hide connection notifications", None))
        self.checkBoxShowTrayNotifications.setText(_translate("settingsDialog", "Show notification when message received", None))
        self.checkBoxPortableMode.setText(_translate("settingsDialog", "Run in Portable Mode", None))
        self.PortableModeDescription.setText(_translate("settingsDialog", "In Portable Mode, messages and config files are stored in the same directory as the program rather than the normal application-data folder. This makes it convenient to run Bitmessage from a USB thumb drive.", None))
        self.checkBoxWillinglySendToMobile.setText(_translate("settingsDialog", "Willingly include unencrypted destination address when sending to a mobile device", None))
        self.checkBoxUseIdenticons.setText(_translate("settingsDialog", "Use Identicons", None))
        self.checkBoxReplyBelow.setText(_translate("settingsDialog", "Reply below Quote", None))
        self.groupBox.setTitle(_translate("settingsDialog", "Interface Language", None))
        self.languageComboBox.setItemText(0, _translate("settingsDialog", "System Settings", "system"))
        self.tabWidgetSettings.setTabText(self.tabWidgetSettings.indexOf(self.tabUserInterface), _translate("settingsDialog", "User Interface", None))
        self.groupBox1.setTitle(_translate("settingsDialog", "Listening port", None))
        self.label.setText(_translate("settingsDialog", "Listen for connections on port:", None))
        self.labelUPnP.setText(_translate("settingsDialog", "UPnP:", None))
        self.groupBox_3.setTitle(_translate("settingsDialog", "Bandwidth limit", None))
        self.label_24.setText(_translate("settingsDialog", "Maximum download rate (kB/s): [0: unlimited]", None))
        self.label_25.setText(_translate("settingsDialog", "Maximum upload rate (kB/s): [0: unlimited]", None))
        self.label_26.setText(_translate("settingsDialog", "Maximum outbound connections: [0: none]", None))
        self.groupBox_2.setTitle(_translate("settingsDialog", "Proxy server / Tor", None))
        self.label_2.setText(_translate("settingsDialog", "Type:", None))
        self.label_3.setText(_translate("settingsDialog", "Server hostname:", None))
        self.label_4.setText(_translate("settingsDialog", "Port:", None))
        self.checkBoxAuthentication.setText(_translate("settingsDialog", "Authentication", None))
        self.label_5.setText(_translate("settingsDialog", "Username:", None))
        self.label_6.setText(_translate("settingsDialog", "Pass:", None))
        self.checkBoxSocksListen.setText(_translate("settingsDialog", "Listen for incoming connections when using proxy", None))
        self.comboBoxProxyType.setItemText(0, _translate("settingsDialog", "none", None))
        self.comboBoxProxyType.setItemText(1, _translate("settingsDialog", "SOCKS4a", None))
        self.comboBoxProxyType.setItemText(2, _translate("settingsDialog", "SOCKS5", None))
        self.tabWidgetSettings.setTabText(self.tabWidgetSettings.indexOf(self.tabNetworkSettings), _translate("settingsDialog", "Network Settings", None))
        self.label_9.setText(_translate("settingsDialog", "Total difficulty:", None))
        self.label_10.setText(_translate("settingsDialog", "The \'Total difficulty\' affects the absolute amount of work the sender must complete. Doubling this value doubles the amount of work.", None))
        self.label_11.setText(_translate("settingsDialog", "Small message difficulty:", None))
        self.label_8.setText(_translate("settingsDialog", "When someone sends you a message, their computer must first complete some work. The difficulty of this work, by default, is 1. You may raise this default for new addresses you create by changing the values here. Any new addresses you create will require senders to meet the higher difficulty. There is one exception: if you add a friend or acquaintance to your address book, Bitmessage will automatically notify them when you next send a message that they need only complete the minimum amount of work: difficulty 1. ", None))
        self.label_12.setText(_translate("settingsDialog", "The \'Small message difficulty\' mostly only affects the difficulty of sending small messages. Doubling this value makes it almost twice as difficult to send a small message but doesn\'t really affect large messages.", None))
        self.tabWidgetSettings.setTabText(self.tabWidgetSettings.indexOf(self.tabDemandedDifficulty), _translate("settingsDialog", "Demanded difficulty", None))
        self.label_15.setText(_translate("settingsDialog", "Here you may set the maximum amount of work you are willing to do to send a message to another person. Setting these values to 0 means that any value is acceptable.", None))
        self.label_13.setText(_translate("settingsDialog", "Maximum acceptable total difficulty:", None))
        self.label_14.setText(_translate("settingsDialog", "Maximum acceptable small message difficulty:", None))
        self.tabWidgetSettings.setTabText(self.tabWidgetSettings.indexOf(self.tabMaxAcceptableDifficulty), _translate("settingsDialog", "Max acceptable difficulty", None))
        self.labelOpenCL.setText(_translate("settingsDialog", "Hardware GPU acceleration (OpenCL):", None))
        self.label_16.setText(_translate("settingsDialog", "<html><head/><body><p>Bitmessage can utilize a different Bitcoin-based program called Namecoin to make addresses human-friendly. For example, instead of having to tell your friend your long Bitmessage address, you can simply tell him to send a message to <span style=\" font-style:italic;\">test. </span></p><p>(Getting your own Bitmessage address into Namecoin is still rather difficult).</p><p>Bitmessage can use either namecoind directly or a running nmcontrol instance.</p></body></html>", None))
        self.label_17.setText(_translate("settingsDialog", "Host:", None))
        self.label_18.setText(_translate("settingsDialog", "Port:", None))
        self.labelNamecoinUser.setText(_translate("settingsDialog", "Username:", None))
        self.labelNamecoinPassword.setText(_translate("settingsDialog", "Password:", None))
        self.pushButtonNamecoinTest.setText(_translate("settingsDialog", "Test", None))
        self.label_21.setText(_translate("settingsDialog", "Connect to:", None))
        self.radioButtonNamecoinNamecoind.setText(_translate("settingsDialog", "Namecoind", None))
        self.radioButtonNamecoinNmcontrol.setText(_translate("settingsDialog", "NMControl", None))
        self.tabWidgetSettings.setTabText(self.tabWidgetSettings.indexOf(self.tabNamecoin), _translate("settingsDialog", "Namecoin integration", None))
        self.label_7.setText(_translate("settingsDialog", "<html><head/><body><p>By default, if you send a message to someone and he is offline for more than two days, Bitmessage will send the message again after an additional two days. This will be continued with exponential backoff forever; messages will be resent after 5, 10, 20 days ect. until the receiver acknowledges them. Here you may change that behavior by having Bitmessage give up after a certain number of days or months.</p><p>Leave these input fields blank for the default behavior. </p></body></html>", None))
        self.label_19.setText(_translate("settingsDialog", "Give up after", None))
        self.label_20.setText(_translate("settingsDialog", "and", None))
        self.label_22.setText(_translate("settingsDialog", "days", None))
        self.label_23.setText(_translate("settingsDialog", "months.", None))
        self.tabWidgetSettings.setTabText(self.tabWidgetSettings.indexOf(self.tabResendsExpire), _translate("settingsDialog", "Resends Expire", None))
